
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Arrays;
import java.util.Scanner;
import java.util.List;

import edu.jhu.nlp.language.Language;
import edu.jhu.nlp.util.HtmlEscape;
import edu.jhu.nlp.util.XMLEncode;
import edu.jhu.nlp.wikipedia.*;

public class SimpleTest {
	public static int pagecount = 0;
	public static String lang = edu.jhu.nlp.language.Language.currLang;
	public static String sourceDir = "/home/michael/Wikipedia-dumps/enwiki-latest-pages-articles.xml";
	public static String targetDir = "/home/michael/Wikipedia-dumps/new_dumps/enwiki-e-cars-dump-complete.xml";
	

    public static String NL = System.getProperty("line.separator");
	
	public static void main(String [] args) throws Exception {
		WikiXMLSAXParser wparser = null;
		if(lang.equals(Language.ENGLISH)) {
			wparser = new WikiXMLSAXParser(sourceDir);
		}
		else if(lang.equals(Language.GERMAN)) {
			wparser = new WikiXMLSAXParser("/home/michael/Wikipedia-dumps/dewiki-latest-pages-articles.xml");
		}
		else {
			System.out.println("Dataset not found.");
			System.exit(1);
		}
		
		// our new dump file to create
		Writer out = null;
		if(!Language.debug) {
		    out = new OutputStreamWriter(new FileOutputStream(targetDir));
		      
			/** print HEAD of dump file **/
		    Scanner scanner = new Scanner(new FileInputStream("/home/michael/Wikipedia-dumps/filesForModifying/dumphead-en.txt"));
		    while (scanner.hasNextLine()){
		    	out.append(scanner.nextLine() + NL);
		    }
		    scanner.close();
		    out.close();
		    System.out.println(".");
		}
        
		PageCallbackHandler handler = new PageCallbackHandler() {
			public void process(WikiPage w) {
				List<String> cats_v = w.getCategories();
//				String[] cats = (String[])cats_v.toArray(new String[cats_v.size()]);
				
				/** PREPROCESSING: MAKE title nicer **/
//				System.out.println(Arrays.toString(cats_v.toArray()));
				
				/** End of preprocessing **/
				
				if(lang.equals(Language.ENGLISH)) {
					/** 1. processing
					if(cats_v.contains("Electric cars")
						|| 	cats_v.contains("Battery electric cars")
						|| 	cats_v.contains("Electric cars")
						|| 	cats_v.contains("Electric city cars")
						|| 	cats_v.contains("Electric sports cars")
						|| 	cats_v.contains("Production Battery electric cars")) {
						pagecount++;
						System.out.println(String.format("%03d", pagecount) + ". ####################################################################");
						System.out.println("TITEL:      " + w.getTitle());
	//					System.out.println("##WIKITEXT: " + w.getWikiText());
						System.out.println("KATEGORIEN: " + Arrays.asList(cats));
						System.out.println("#########################################################################");
						System.out.println();
					}
					**/
					/** 2. processing
					if(cats_v.contains("Electric cars")
							|| 	cats_v.contains("Battery electric cars")
							|| 	cats_v.contains("Electric cars")
							|| 	cats_v.contains("Electric city cars")
							|| 	cats_v.contains("Electric sports cars")
							|| 	cats_v.contains("Production Battery electric cars")) {
						pagecount++;
						System.out.println(String.format("%03d", pagecount) + ".");
						System.out.print("EN: " + w.getTitle() + " | DE: " + w.getTranslatedTitle("de"));
						System.out.println();
						System.out.println("NS:" + w.getNS() + " | Timestamp: " + w.getRevTimestamp() + " | SHA1: " + w.getHashSHA1());
						}
					**/
					// 3. processing: create part dump
					if(cats_v.contains("Electric cars")
							|| 	cats_v.contains("Battery electric cars")
							|| 	cats_v.contains("Electric cars")
							|| 	cats_v.contains("Electric city cars")
							|| 	cats_v.contains("Electric sports cars")
							|| 	cats_v.contains("Production Battery electric cars")
							// in addition add category page (electric cars) itself==rootdirectory
							// and disambiguation templates/category etc., cf. wikifier/languages.xml
							|| w.getTitle().equals("Category:Electric cars")
							|| w.getTitle().equals("Category:Disambiguation")
							|| w.getTitle().equals("Template:disambiguation")
							|| w.getTitle().equals("Template:disambig")
							|| w.getTitle().equals("Template:geodis")
							|| w.getTitle().equals("Template:hndis")
							|| w.getTitle().equals("Template:hospitaldis")
							|| w.getTitle().equals("Template:mathdab")
							|| w.getTitle().equals("Template:mountianindex")
							|| w.getTitle().equals("Template:numberdis")
							|| w.getTitle().equals("Template:roaddis")
							|| w.getTitle().equals("Template:schooldis")
							|| w.getTitle().equals("Template:shipindex")
							|| w.getTitle().equals("Template:SIA")
							) {
						pagecount++;
					    Writer out;
						try {
							// "UTF-8"
							out = new OutputStreamWriter(new FileOutputStream(targetDir, true));
							out.append("  <page>" + NL + "    <title>" + w.getTitle() + "</title>" + NL);
							out.append("    <ns>" + w.getNS() + "</ns>" + NL);
							out.append("    <id>" + w.getID() + "</id>" + NL);
							if(w.getRedirectPage() != null) {
								out.append("    <redirect title=\"" + w.getRedirectPage() + "\" />");
							}
							out.append("    <revision>" + NL);
							out.append("      <id>1</id>" + NL);
							out.append("      <parentid>" + w.getRevParentID() + "</parentid>" + NL);
							out.append("      <timestamp>" + w.getRevTimestamp() + "</timestamp>" + NL);
							out.append("      <contributor>" + NL);
							out.append("        <username>Zeus</username>" + NL);
							out.append("        <id>1</id>" + NL);
							out.append("      </contributor>" + NL);
							if(w.getMinor()) {
								out.append("      <minor />" + NL);
//								System.out.println(w.getTitle() + ": minor");
							}
//							else{
//								System.out.println(w.getTitle() + ": no minor");
//							}
							out.append("      <comment></comment>" + NL);
							out.append("      <sha1>" + w.getHashSHA1()+ "</sha1>" + NL);
							out.append("      <text xml:space=\"preserve\">" + XMLEncode.encodeXmlAttribute(w.getWikiText()) + "</text>" + NL);
							out.append("    </revision>" + NL);
							out.append("  </page>" + NL);
							out.close();
						} catch (FileNotFoundException e) {
							e.printStackTrace();
						} catch (IOException e) {
							e.printStackTrace();
						}

						
						}
						
				}
				/** ACHTUNG: JE NACH SPRACHE in WikiTextParser.java Category in Kategorie etc. umändern!!! **/
				else if(lang.equals(Language.GERMAN)){
					/**
					if(cats_v.contains("Ehemaliger Elektroautohersteller")
							|| 	cats_v.contains("Elektroauto")
							|| 	cats_v.contains("Elektroautohersteller")
							|| 	cats_v.contains("Hybridelektroauto")) {
							pagecount++;
							System.out.println(String.format("%03d", pagecount) + ". ####################################################################");
							System.out.println("TITEL:      " + w.getTitle());
		//					System.out.println("##WIKITEXT: " + w.getWikiText());
							System.out.println("KATEGORIEN: " + Arrays.asList(cats));
							System.out.println("#########################################################################");
							System.out.println();
						}
						**/
//					if(cats_v.contains("Ehemaliger Elektroautohersteller")
//							|| 	cats_v.contains("Elektroauto")
//							|| 	cats_v.contains("Elektroautohersteller")
//							|| 	cats_v.contains("Hybridelektroauto")) {
							pagecount++;
							System.out.println(String.format("%03d", pagecount) + ".");
							System.out.print("DE: " + w.getTitle() + " | EN: " + w.getTranslatedTitle("en"));
							System.out.println();
//					}
				}
			}
		};
		
		wparser.setPageCallback(handler);
		wparser.parse();
		
		if(!Language.debug) {
			out = new OutputStreamWriter(new FileOutputStream(targetDir, true));
			out.append("</mediawiki>");
			out.close();
		}

		System.out.println("FINIS!");
		
	}
	
	/** NOT USED:
	  static void runRESTAPI() throws IOException {
		    System.out.println("=== GET: execute a query ===");

		    // The java URL connection to the resource
		    String base = "http://en.wikipedia.org/w/";

		    URL url = new URL(base + "api.php?action=query&cmtitle=USA");
		    System.out.println("\n* URL: " + url);

		    // Establish the connection to the URL
		    HttpURLConnection conn = (HttpURLConnection) url.openConnection();

		    // Print the HTTP response code
		    int code = conn.getResponseCode();
		    System.out.println("\n* HTTP response: " + code +
		        " (" + conn.getResponseMessage() + ')');

		    // Check if request was successful
		    if(code == HttpURLConnection.HTTP_OK) {
		      // Print the received result to standard output
		      System.out.println("\n* Result:");

		      // Get and cache input as UTF-8 encoded stream
		      BufferedReader br = new BufferedReader(new InputStreamReader(
		          conn.getInputStream(), "UTF-8"));

		      // Print all lines of the result
		      for(String line; (line = br.readLine()) != null;) {
		        System.out.println(line);
		      }
		      br.close();
		    }

		    // Close connection
		    conn.disconnect();
		  }
		  **/
}
